//==============================================================================
//	 RoboBuilder MainController Sample Program	1.0
//										2008.04.14	Robobuilder co., ltd.
//   ҽڵ Tab Size = 4  Ǿϴ
//==============================================================================
#include <mega128.h>

// Standard Input/Output functions
#include <stdio.h>
#include <delay.h>

#include "Macro.h"
#include "Main.h"
#include "Comm.h"
#include "Dio.h"
#include "math.h"

// ÷----------------------------------------------------------------------
bit 	F_PLAYING;				//   ǥ
bit 	F_DIRECT_C_EN;			// wCK  (1:, 0:Ұ)

// ư Է ó------------------------------------------------------------
WORD    gBtnCnt;				// ư  ó ī

// ð -----------------------------------------------------------------
WORD    gMSEC;
BYTE    gSEC;
BYTE    gMIN;
BYTE    gHOUR;

// UART ſ-----------------------------------------------------------------
char	gTx0Buf[TX0_BUF_SIZE];		// UART0 ۽ 
BYTE	gTx0Cnt;					// UART0 ۽  Ʈ 
BYTE	gRx0Cnt;					// UART0  Ʈ 
BYTE	gTx0BufIdx;					// UART0 ۽  ε
char	gRx0Buf[RX0_BUF_SIZE];		// UART0  
BYTE	gOldRx1Byte;				// UART1 ֱ  Ʈ
char	gRx1Buf[RX1_BUF_SIZE];		// UART1  
BYTE	gRx1Index;					// UART1  ۿ ε
WORD	gRx1Step;					// UART1  Ŷ ܰ 
WORD	gRx1_DStep;					//  忡 UART1  Ŷ ܰ 
WORD	gFieldIdx;					// ʵ Ʈ ε
WORD	gFileByteIndex;				//  Ʈ ε
BYTE	gFileCheckSum;				// ϳ CheckSum
BYTE	gRxData;					// ŵ 

//  -----------------------------------------------------------------
int		gFrameIdx=0;	    // ̺  ε
WORD	TxInterval=0;		//  ۽ 
float	gUnitD[MAX_wCK];	//   
BYTE flash	*gpT_Table;		//  ũ ̺ 
BYTE flash	*gpE_Table;		//  ȮƮ ̺ 
BYTE flash	*gpPg_Table;	//  Runtime P̵ ̺ 
BYTE flash	*gpDg_Table;	//  Runtime D̵ ̺ 
BYTE flash	*gpIg_Table;	//  Runtime I̵ ̺ 
WORD flash	*gpFN_Table;	//    ̺ 
WORD flash	*gpRT_Table;	//  ð ̺ 
BYTE flash	*gpPos_Table;	//  ġ ̺ 

// ׼   ü
//      - ũ : wCK < Frame < Scene < Motion < Action
//      -  wCK  Frame ̷
//         Frame   Scene ̷
//         Scene   Motion ̷
//         Motion   Action ̷

struct TwCK_in_Motion{  //   ǿ ϴ wCK 
	BYTE	Exist;			// wCK 
	BYTE	RPgain;			// Runtime P̵
	BYTE	RDgain;			// Runtime D̵
	BYTE	RIgain;			// Runtime I̵
	BYTE	PortEn;			// ȮƮ (0:, 1:)
	BYTE	InitPos;		//     κ  ġ
};

struct TwCK_in_Scene{	//    ϴ wCK 
	BYTE	Exist;			// wCK 
	BYTE	SPos;			// ù  wCK ġ
	BYTE	DPos;			//   wCK ġ
	BYTE	Torq;			// ũ
	BYTE	ExPortD;		// ȮƮ  (1~3)
};

struct TMotion{			//   ǿ ϴ 
	BYTE	PF;				// ǿ ´ ÷
	BYTE	RIdx;			//   ε
	DWORD	AIdx;			//   ε
	WORD	NumOfScene;		//  
	WORD	NumOfwCK;		// wCK 
	struct	TwCK_in_Motion  wCK[MAX_wCK];	// wCK Ķ
	WORD	FileSize;		//  ũ
}Motion;

struct TScene{			//    ϴ 
	WORD	Idx;			//  ε(0~65535)
	WORD	NumOfFrame;		//  
	WORD	RTime;			//   ð[msec]
	struct	TwCK_in_Scene   wCK[MAX_wCK];	// wCK 
}Scene;

WORD	gSIdx;			//  ε(0~65535)

//------------------------------------------------------------------------------
// UART0 ۽ ͷƮ(Ŷ ۽ſ)
//------------------------------------------------------------------------------
interrupt [USART0_TXC] void usart0_tx_isr(void) {
	if(gTx0BufIdx<gTx0Cnt){			//  Ͱ 
    	while(!(UCSR0A&(1<<UDRE))); 	//  Ʈ  Ϸɶ 
		UDR0=gTx0Buf[gTx0BufIdx];		// 1Ʈ ۽
    	gTx0BufIdx++;      				//  ε 
	}
	else if(gTx0BufIdx==gTx0Cnt){	// ۽ Ϸ
		gTx0BufIdx = 0;					//  ε ʱȭ
		gTx0Cnt = 0;					// ۽  Ʈ ʱȭ
	}
}


//------------------------------------------------------------------------------
// UART0  ͷƮ(wCK, ⿡  ȣ)
//------------------------------------------------------------------------------
interrupt [USART0_RXC] void usart0_rx_isr(void)
{
	int		i;
    char	data;
	data=UDR0;
	gRx0Cnt++;
    // ŵ͸ FIFO 
   	for(i=1; i<RX0_BUF_SIZE; i++) gRx0Buf[i-1] = gRx0Buf[i];
   	gRx0Buf[RX0_BUF_SIZE-1] = data;
}


//------------------------------------------------------------------------------
// Ÿ̸0 ÷ ͷƮ (ð  0.998ms )
//------------------------------------------------------------------------------
interrupt [TIM0_OVF] void timer0_ovf_isr(void) {
	TCNT0 = 25;
	// 1ms  
    if(++gMSEC>999){
		// 1s  
        gMSEC=0;
        if(++gSEC>59){
			// 1m  
            gSEC=0;
            if(++gMIN>59){
				// 1h  
                gMIN=0;
                if(++gHOUR>23)
                    gHOUR=0;
            }
        }
    }
}


//------------------------------------------------------------------------------
// Ÿ̸1 ÷ ͷƮ ( ۽)
//------------------------------------------------------------------------------
interrupt [TIM1_OVF] void timer1_ovf_isr(void) {
	if( gFrameIdx == Scene.NumOfFrame ) {   //  ̾
   	    gFrameIdx = 0;
    	RUN_LED1_OFF;
		F_PLAYING=0;		//   ǥ
		TIMSK &= 0xfb;  	// Timer1 Overflow Interrupt 
		TCCR1B=0x00;
		return;
	}
	TCNT1=TxInterval;
	TIFR |= 0x04;		// Ÿ̸ ͷƮ ÷ ʱȭ
	TIMSK |= 0x04;		// Timer1 Overflow Interrupt Ȱȭ(140)
	MakeFrame();		//   غ
	SendFrame();		//   ۽
}


//------------------------------------------------------------------------------
// ϵ ʱȭ
//------------------------------------------------------------------------------
void HW_init(void) {
	// Input/Output Ports initialization
	// Port A initialization
	// Func7=Out Func6=Out Func5=Out Func4=Out Func3=Out Func2=Out Func1=In Func0=In 
	// State7=0 State6=0 State5=0 State4=0 State3=0 State2=0 State1=P State0=P 
	PORTA=0x03;
	DDRA=0xFC;

	// Port B initialization
	// Func7=In Func6=Out Func5=Out Func4=Out Func3=In Func2=Out Func1=In Func0=In 
	// State7=T State6=0 State5=0 State4=0 State3=T State2=0 State1=T State0=T 
	PORTB=0x00;
	DDRB=0x74;

	// Port C initialization
	// Func7=Out Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
	// State7=0 State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
	PORTC=0x00;
	DDRC=0x80;

	// Port D initialization
	// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
	// State7=T State6=T State5=T State4=T State3=T State2=T State1=P State0=P 
	PORTD=0x83;
	DDRD=0x80;

	// Port E initialization
	// Func7=In Func6=In Func5=In Func4=In Func3=Out Func2=In Func1=In Func0=In 
	// State7=T State6=P State5=P State4=P State3=0 State2=T State1=T State0=T 
	PORTE=0x70;
	DDRE=0x08;

	// Port F initialization
	// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
	// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
	PORTF=0x00;
	DDRF=0x00;

	// Port G initialization
	// Func4=In Func3=In Func2=Out Func1=In Func0=In 
	// State4=T State3=T State2=0 State1=T State0=T 
	PORTG=0x00;
	DDRG=0x04;

	// Ÿ̸ 0---------------------------------------------------------------
	// :  ð  (ms )
	// Timer/Counter 0 initialization
	// Clock source: System Clock
	// Clock value: 230.400 kHz
	// Clock  ֱ = 1/230400 = 4.34us
	// Overflow ð = 255*1/230400 = 1.107ms
	// 1ms ֱ overflow  īƮ ۰ =  255-230 = 25
	// Mode: Normal top=FFh
	// OC0 output: Disconnected
	ASSR=0x00;
	TCCR0=0x04;
	TCNT0=0x00;
	OCR0=0x00;

	// Ÿ̸ 1---------------------------------------------------------------
	// :  ÷̽  ۽   
	// Timer/Counter 1 initialization
	// Clock source: System Clock
	// Clock value: 14.400 kHz
	// Clock  ֱ = 1/14400 = 69.4us
	// Mode: Normal top=FFFFh
	// OC1A output: Discon.
	// OC1B output: Discon.
	// OC1C output: Discon.
	// Noise Canceler: Off
	// Input Capture on Falling Edge
	// Timer 1 Overflow Interrupt: On
	// Input Capture Interrupt: Off
	// Compare A Match Interrupt: Off
	// Compare B Match Interrupt: Off
	// Compare C Match Interrupt: Off
	TCCR1A=0x00;
	TCCR1B=0x05;
	TCNT1H=0x00;
	TCNT1L=0x00;
	ICR1H=0x00;
	ICR1L=0x00;
	OCR1AH=0x00;
	OCR1AL=0x00;
	OCR1BH=0x00;
	OCR1BL=0x00;
	OCR1CH=0x00;
	OCR1CL=0x00;

	// Ÿ̸ 2---------------------------------------------------------------
	// Timer/Counter 2 initialization
	// Clock source: System Clock
	// Clock value: 14.400 kHz
	// Clock  ֱ = 1/14400 = 69.4us
	// Mode: Normal top=FFh
	// OC2 output: Disconnected
	TCCR2=0x05;
	TCNT2=0x00;
	OCR2=0x00;

	// Ÿ̸ 3---------------------------------------------------------------
	// : ӵ  ȣ м 
	TCCR3A=0x00;
	TCCR3B=0x03;
	TCNT3H=0x00;
	TCNT3L=0x00;
	ICR3H=0x00;
	ICR3L=0x00;
	OCR3AH=0x00;
	OCR3AL=0x00;
	OCR3BH=0x00;
	OCR3BL=0x00;
	OCR3CH=0x00;
	OCR3CL=0x00;

	// External Interrupt(s) initialization
	// INT0: Off
	// INT1: Off
	// INT2: Off
	// INT3: Off
	// INT4: Off
	// INT5: Off
	// INT6: Off
	// INT7: Off
	EICRA=0x00;
	EICRB=0x00;
	EIMSK=0x00;

	// Timer(s)/Counter(s) Interrupt(s) initialization
	TIMSK=0x00;
	ETIMSK=0x00;

	// USART0 initialization
	// Communication Parameters: 8 Data, 1 Stop, No Parity
	// USART0 Receiver: Off
	// USART0 Transmitter: On
	// USART0 Mode: Asynchronous
	// USART0 Baud rate: 115200
	UCSR0A=0x00;
	UCSR0B=0x48;
	UCSR0C=0x06;
	UBRR0H=0x00;
	UBRR0L=0x07;

	// USART1 initialization
	// Communication Parameters: 8 Data, 1 Stop, No Parity
	// USART1 Receiver: On
	// USART1 Transmitter: On
	// USART1 Mode: Asynchronous
	// USART1 Baud rate: 115200
	UCSR1A=0x00;
	UCSR1B=0x18;		// ͷƮ 
	UCSR1C=0x06;
	UBRR1H=0x00;
	UBRR1L=BR115200;	// UART1  BAUD RATE 115200 

	TWCR = 0;
}


//------------------------------------------------------------------------------
// ÷ ʱȭ
//------------------------------------------------------------------------------
void SW_init(void) {
	PF1_LED1_OFF;
	PF1_LED2_OFF;
	PF2_LED_OFF;
	PWR_LED1_OFF;
	PWR_LED2_OFF;
	RUN_LED1_OFF;
	RUN_LED2_OFF;
	ERR_LED_OFF;
	F_PLAYING = 0;          //  ƴ

	gTx0Cnt = 0;			// UART0 ۽  Ʈ 
	gTx0BufIdx = 0;			// TX0  ε ʱȭ
	PSD_OFF;                // PSD Ÿ  OFF
	gMSEC=0;
	gSEC=0;
	gMIN=0;
	gHOUR=0;
}


void SpecialMode(void)
{
	int i;

	// PF2 ư  wCK   
	if(PINA.0==1 && PINA.1==0){
		delay_ms(10);
		if(PINA.0==1){
		    TIMSK &= 0xFE;     // Timer0 Overflow Interrupt ̻
			EIMSK &= 0xBF;		// EXT6( ) ͷƮ ̻
			UCSR0B |= 0x80;   	// UART0 RxͷƮ 
			UCSR0B &= 0xBF;   	// UART0 TxͷƮ ̻
		}
	}
}

//------------------------------------------------------------------------------
//  Լ
//------------------------------------------------------------------------------
void main(void) {
	WORD    i, lMSEC;

	HW_init();			// ϵ ʱȭ
	SW_init();			//  ʱȭ

	#asm("sei");
	TIMSK |= 0x01;		// Timer0 Overflow Interrupt Ȱȭ

	SpecialMode();

	while(1){
		/*
		lMSEC = gMSEC;
		ReadButton();	    // ư б
		IoUpdate();		    // IO  UPDATE
		while(lMSEC==gMSEC);
		*/
		PWR_LED2_ON;    delay_ms(500);
		PWR_LED2_OFF;    delay_ms(500);
    }
}
