//==========================================================
// Project : [ HunoBasic ]
// SoftWare : Motion Builder v1.13 beta
// Date,Time : 2008-08-19  11:37:46
// Format : ME_FMT#1
// Number of Motions : 10
// Number of wCKs : 16
//==========================================================

//unsigned char flash wCK_IDs[16]={
//	  0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15
//};
//unsigned char flash MotionZeroPos[16]={
//	/* ID
//	  0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15 */
//	125,201,163, 67,108,125, 48, 89,184,142, 89, 39,124,162,211,127
//};


//----------------------------------------------------------
// Motion Name : HUNOBASIC_PUNCHLEFT
//----------------------------------------------------------
#define HUNOBASIC_PUNCHLEFT_NUM_OF_SCENES 5
#define HUNOBASIC_PUNCHLEFT_NUM_OF_WCKS 16
unsigned char flash HUNOBASIC_PUNCHLEFT_RuntimePGain[16]={
	/* ID
	  0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15 */
	 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 15, 15, 15, 15, 15, 15
};
unsigned char flash HUNOBASIC_PUNCHLEFT_RuntimeDGain[16]={
	/* ID
	  0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15 */
	 60, 60, 60, 60, 60, 60, 60, 60, 60, 60, 20, 20, 20, 20, 20, 20
};
unsigned char flash HUNOBASIC_PUNCHLEFT_RuntimeIGain[16]={
	/* ID
	  0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15 */
	  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
};
unsigned int flash HUNOBASIC_PUNCHLEFT_Frames[5]={
	    1,    8,    1,    5,   15
};
unsigned int flash HUNOBASIC_PUNCHLEFT_TrTime[5]={
	   70,  310,  420,  200,  300
};
unsigned char flash HUNOBASIC_PUNCHLEFT_Position[6][16]={
	/* ID
	    0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15 */
	{ 125,179,199, 88,108,126, 72, 49,163,141, 51, 47, 49,199,205,205 },
	{ 125,179,199, 88,108,126, 72, 49,163,141, 51, 47, 49,199,205,205 },	// Idx:0 - Data_0
	{ 107,164,233,106, 95,108, 80, 29,155,129, 56, 62, 40,166,206,208 },	// Idx:1 - Scene_1
	{ 107,164,233,106, 95,145, 74, 40,163,154,117,124,114,166,206,208 },	// Idx:2 - Scene_2
	{ 126,164,222,100,107,125, 80, 29,155,142, 79, 44, 40,166,206,208 },	// Idx:3 - Scene_4
	{ 125,179,199, 88,108,126, 72, 49,163,141, 51, 47, 49,199,205,205 } 	// Idx:4 - Data_0
};
unsigned char flash HUNOBASIC_PUNCHLEFT_Torque[5][16]={
	/* ID
	    0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15 */
	{   4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4 },	// Idx:0 - Data_0
	{   2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  0,  0,  0,  0,  0,  0 },	// Idx:1 - Scene_1
	{   1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1 },	// Idx:2 - Scene_2
	{   2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2 },	// Idx:3 - Scene_4
	{   4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4 } 	// Idx:4 - Data_0
};
unsigned char flash HUNOBASIC_PUNCHLEFT_Port[5][16]={
	/* ID
	    0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15 */
	{   1,  1,  1,  1,  1,  0,  0,  0,  0,  0,  1,  1,  1,  0,  0,  0 },	// Idx:0 - Data_0
	{   1,  1,  1,  1,  1,  0,  0,  0,  0,  0,  1,  1,  1,  0,  0,  0 },	// Idx:1 - Scene_1
	{   3,  3,  3,  3,  3,  0,  0,  0,  0,  0,  3,  3,  3,  0,  0,  0 },	// Idx:2 - Scene_2
	{   3,  3,  3,  3,  3,  0,  0,  0,  0,  0,  3,  3,  3,  0,  0,  0 },	// Idx:3 - Scene_4
	{   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0 } 	// Idx:4 - Data_0
};

//----------------------------------------------------------
// Motion Name : HUNOBASIC_PUNCHRIGHT
//----------------------------------------------------------
#define HUNOBASIC_PUNCHRIGHT_NUM_OF_SCENES 5
#define HUNOBASIC_PUNCHRIGHT_NUM_OF_WCKS 16
unsigned char flash HUNOBASIC_PUNCHRIGHT_RuntimePGain[16]={
	/* ID
	  0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15 */
	 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 15, 15, 15, 15, 15, 15
};
unsigned char flash HUNOBASIC_PUNCHRIGHT_RuntimeDGain[16]={
	/* ID
	  0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15 */
	 60, 60, 60, 60, 60, 60, 60, 60, 60, 60, 20, 20, 20, 20, 20, 20
};
unsigned char flash HUNOBASIC_PUNCHRIGHT_RuntimeIGain[16]={
	/* ID
	  0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15 */
	  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
};
unsigned int flash HUNOBASIC_PUNCHRIGHT_Frames[5]={
	    1,    8,    1,    5,   15
};
unsigned int flash HUNOBASIC_PUNCHRIGHT_TrTime[5]={
	   70,  310,  420,  200,  300
};
unsigned char flash HUNOBASIC_PUNCHRIGHT_Position[6][16]={
	/* ID
	    0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15 */
	{ 125,179,199, 88,108,126, 72, 49,163,141, 51, 47, 49,199,205,205 },
	{ 125,179,199, 88,108,126, 72, 49,163,141, 51, 47, 49,199,205,205 },	// Idx:0 - Data_0
	{ 141,163,230,100,122,142, 87, 14,150,159, 79, 44, 40,187,194,208 },	// Idx:1 - Scene_1
	{ 105,164,224, 97,106,145, 80, 28,153,167, 79, 44, 40,119,127,131 },	// Idx:2 - Scene_2
	{ 126,164,222,100,107,125, 80, 29,155,142, 79, 44, 40,166,206,208 },	// Idx:3 - Scene_4
	{ 125,179,199, 88,108,126, 72, 49,163,141, 51, 47, 49,199,205,205 } 	// Idx:4 - Data_0
};
unsigned char flash HUNOBASIC_PUNCHRIGHT_Torque[5][16]={
	/* ID
	    0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15 */
	{   4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4 },	// Idx:0 - Data_0
	{   2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  0,  0,  0,  0,  0,  0 },	// Idx:1 - Scene_1
	{   1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1 },	// Idx:2 - Scene_2
	{   2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2 },	// Idx:3 - Scene_4
	{   4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4 } 	// Idx:4 - Data_0
};
unsigned char flash HUNOBASIC_PUNCHRIGHT_Port[5][16]={
	/* ID
	    0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15 */
	{   0,  0,  0,  0,  0,  1,  1,  1,  1,  1,  0,  0,  0,  1,  1,  1 },	// Idx:0 - Data_0
	{   0,  0,  0,  0,  0,  2,  2,  2,  2,  2,  0,  0,  0,  2,  2,  2 },	// Idx:1 - Scene_1
	{   0,  0,  0,  0,  0,  3,  3,  3,  3,  2,  0,  0,  0,  3,  3,  3 },	// Idx:2 - Scene_2
	{   0,  0,  0,  0,  0,  3,  3,  3,  3,  3,  0,  0,  0,  3,  3,  3 },	// Idx:3 - Scene_4
	{   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0 } 	// Idx:4 - Data_0
};

//----------------------------------------------------------
// Motion Name : HUNOBASIC_SIDEWALKLEFT
//----------------------------------------------------------
#define HUNOBASIC_SIDEWALKLEFT_NUM_OF_SCENES 6
#define HUNOBASIC_SIDEWALKLEFT_NUM_OF_WCKS 16
unsigned char flash HUNOBASIC_SIDEWALKLEFT_RuntimePGain[16]={
	/* ID
	  0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15 */
	 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 15, 15, 15, 15, 15, 15
};
unsigned char flash HUNOBASIC_SIDEWALKLEFT_RuntimeDGain[16]={
	/* ID
	  0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15 */
	 60, 60, 60, 60, 60, 60, 60, 60, 60, 60, 20, 20, 20, 20, 20, 20
};
unsigned char flash HUNOBASIC_SIDEWALKLEFT_RuntimeIGain[16]={
	/* ID
	  0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15 */
	  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
};
unsigned int flash HUNOBASIC_SIDEWALKLEFT_Frames[6]={
	    1,    5,    8,    3,    1,   15
};
unsigned int flash HUNOBASIC_SIDEWALKLEFT_TrTime[6]={
	   70,  150,  310,  250,  120,  300
};
unsigned char flash HUNOBASIC_SIDEWALKLEFT_Position[7][16]={
	/* ID
	    0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15 */
	{ 125,179,199, 88,108,126, 72, 49,163,141, 51, 47, 49,199,205,205 },
	{ 125,179,199, 88,108,126, 72, 49,163,141, 51, 47, 49,199,205,205 },	// Idx:0 - Data_0
	{ 126,167,222, 98,110,125, 84, 29,155,142, 79, 44, 40,166,206,208 },	// Idx:1 - Data
	{ 107,164,233,102, 95,108, 80, 29,155,129, 56, 62, 40,166,206,208 },	// Idx:2 - Scene_1
	{ 107,164,233,105, 95,145, 74, 40,157,154, 56, 62, 40,166,206,208 },	// Idx:3 - Scene_2
	{ 126,164,222, 95,107,125, 84, 29,155,142, 79, 44, 40,166,206,208 },	// Idx:4 - Data
	{ 125,179,199, 88,108,126, 72, 49,163,141, 51, 47, 49,199,205,205 } 	// Idx:5 - Data
};
unsigned char flash HUNOBASIC_SIDEWALKLEFT_Torque[6][16]={
	/* ID
	    0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15 */
	{   4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4 },	// Idx:0 - Data_0
	{   4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4 },	// Idx:1 - Data
	{   2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  0,  0,  0,  0,  0,  0 },	// Idx:2 - Scene_1
	{   2,  2,  2,  2,  2,  0,  0,  0,  0,  0,  3,  3,  3,  3,  3,  3 },	// Idx:3 - Scene_2
	{   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  4,  4,  4,  4,  4,  3 },	// Idx:4 - Data
	{   4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4 } 	// Idx:5 - Data
};
unsigned char flash HUNOBASIC_SIDEWALKLEFT_Port[6][16]={
	/* ID
	    0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15 */
	{   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0 },	// Idx:0 - Data_0
	{   1,  1,  1,  1,  1,  0,  0,  0,  0,  0,  1,  1,  1,  0,  0,  0 },	// Idx:1 - Data
	{   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0 },	// Idx:2 - Scene_1
	{   1,  1,  1,  1,  1,  0,  0,  0,  0,  0,  1,  1,  1,  0,  0,  0 },	// Idx:3 - Scene_2
	{   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0 },	// Idx:4 - Data
	{   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0 } 	// Idx:5 - Data
};

//----------------------------------------------------------
// Motion Name : HUNOBASIC_SIDEWALKRIGHT
//----------------------------------------------------------
#define HUNOBASIC_SIDEWALKRIGHT_NUM_OF_SCENES 6
#define HUNOBASIC_SIDEWALKRIGHT_NUM_OF_WCKS 16
unsigned char flash HUNOBASIC_SIDEWALKRIGHT_RuntimePGain[16]={
	/* ID
	  0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15 */
	 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 15, 15, 15, 15, 15, 15
};
unsigned char flash HUNOBASIC_SIDEWALKRIGHT_RuntimeDGain[16]={
	/* ID
	  0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15 */
	 60, 60, 60, 60, 60, 60, 60, 60, 60, 60, 20, 20, 20, 20, 20, 20
};
unsigned char flash HUNOBASIC_SIDEWALKRIGHT_RuntimeIGain[16]={
	/* ID
	  0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15 */
	  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
};
unsigned int flash HUNOBASIC_SIDEWALKRIGHT_Frames[6]={
	    1,    5,    8,    3,    1,   15
};
unsigned int flash HUNOBASIC_SIDEWALKRIGHT_TrTime[6]={
	   70,  150,  310,  200,  120,  300
};
unsigned char flash HUNOBASIC_SIDEWALKRIGHT_Position[7][16]={
	/* ID
	    0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15 */
	{ 125,179,199, 88,108,126, 72, 49,163,141, 51, 47, 49,199,205,205 },
	{ 125,179,199, 88,108,126, 72, 49,163,141, 51, 47, 49,199,205,205 },	// Idx:0 - Data_0
	{ 126,167,222, 98,110,125, 84, 29,155,142, 79, 44, 40,166,206,208 },	// Idx:1 - Data
	{ 139,163,230,100,120,142, 87, 14,150,159, 79, 44, 40,183,188,208 },	// Idx:2 - Scene_1
	{ 108,164,224, 97,106,151, 80, 28,153,167, 79, 44, 40,183,188,208 },	// Idx:3 - Scene_2
	{ 126,166,222, 98,113,125, 84, 29,155,142, 79, 44, 40,166,206,208 },	// Idx:4 - Data
	{ 125,179,199, 88,108,126, 72, 49,163,141, 51, 47, 49,199,205,205 } 	// Idx:5 - Scene_4
};
unsigned char flash HUNOBASIC_SIDEWALKRIGHT_Torque[6][16]={
	/* ID
	    0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15 */
	{   4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4 },	// Idx:0 - Data_0
	{   4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4 },	// Idx:1 - Data
	{   2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  4,  4,  4,  4,  4 },	// Idx:2 - Scene_1
	{   0,  0,  0,  0,  0,  2,  2,  2,  2,  2,  4,  4,  4,  4,  4,  4 },	// Idx:3 - Scene_2
	{   0,  0,  0,  0,  0,  2,  2,  2,  2,  2,  4,  4,  4,  4,  4,  4 },	// Idx:4 - Data
	{   4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4 } 	// Idx:5 - Scene_4
};
unsigned char flash HUNOBASIC_SIDEWALKRIGHT_Port[6][16]={
	/* ID
	    0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15 */
	{   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0 },	// Idx:0 - Data_0
	{   0,  0,  0,  0,  0,  1,  1,  1,  1,  1,  0,  0,  0,  1,  1,  1 },	// Idx:1 - Data
	{   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0 },	// Idx:2 - Scene_1
	{   0,  0,  0,  0,  0,  1,  1,  1,  1,  1,  0,  0,  0,  1,  1,  1 },	// Idx:3 - Scene_2
	{   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0 },	// Idx:4 - Data
	{   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0 } 	// Idx:5 - Scene_4
};

//----------------------------------------------------------
// Motion Name : HUNOBASIC_TURNLEFT
//----------------------------------------------------------
#define HUNOBASIC_TURNLEFT_NUM_OF_SCENES 6
#define HUNOBASIC_TURNLEFT_NUM_OF_WCKS 16
unsigned char flash HUNOBASIC_TURNLEFT_RuntimePGain[16]={
	/* ID
	  0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15 */
	 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 15, 15, 15, 15, 15, 15
};
unsigned char flash HUNOBASIC_TURNLEFT_RuntimeDGain[16]={
	/* ID
	  0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15 */
	 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 20, 20, 20, 20, 20, 20
};
unsigned char flash HUNOBASIC_TURNLEFT_RuntimeIGain[16]={
	/* ID
	  0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15 */
	  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
};
unsigned int flash HUNOBASIC_TURNLEFT_Frames[6]={
	   10,    5,   10,    1,    5,   10
};
unsigned int flash HUNOBASIC_TURNLEFT_TrTime[6]={
	  200,  200,  400,  120,  200,  400
};
unsigned char flash HUNOBASIC_TURNLEFT_Position[7][16]={
	/* ID
	    0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15 */
	{ 125,179,199, 88,108,126, 72, 49,163,141, 51, 47, 49,199,205,205 },
	{ 125,179,199, 88,108,126, 72, 49,163,141, 51, 47, 49,199,205,205 },	// Idx:0 - Data_0
	{ 125,162,199, 72,108,126, 59, 49,151,141, 51, 47, 49,199,205,205 },	// Idx:1 - Data
	{ 136,169,210, 93,121,139, 36, 61,144,157, 51, 47, 49,199,205,205 },	// Idx:2 - Data_2
	{ 125,173,210, 93,123,139, 80, 14,137,157, 51, 47, 49,199,205,205 },	// Idx:3 - Data_3
	{ 134,173,210, 93,123,139, 80, 31,157,157, 51, 47, 49,199,205,205 },	// Idx:4 - Data_4
	{ 125,179,199, 88,108,126, 72, 49,163,141, 51, 47, 49,199,205,205 } 	// Idx:5 - Data_5
};
unsigned char flash HUNOBASIC_TURNLEFT_Torque[6][16]={
	/* ID
	    0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15 */
	{   4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4 },	// Idx:0 - Data_0
	{   1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  4,  4,  4,  4,  4,  4 },	// Idx:1 - Data
	{   1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  4,  4,  4,  4,  4,  4 },	// Idx:2 - Data_2
	{   2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  4,  4,  4,  4,  4 },	// Idx:3 - Data_3
	{   1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  4,  4,  4,  4,  4,  4 },	// Idx:4 - Data_4
	{   3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  4,  4,  4,  4,  4,  4 } 	// Idx:5 - Data_5
};
unsigned char flash HUNOBASIC_TURNLEFT_Port[6][16]={
	/* ID
	    0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15 */
	{   1,  1,  1,  1,  1,  0,  0,  0,  0,  0,  1,  1,  1,  0,  0,  0 },	// Idx:0 - Data_0
	{   1,  1,  1,  1,  1,  0,  0,  0,  0,  0,  1,  1,  1,  0,  0,  0 },	// Idx:1 - Data
	{   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0 },	// Idx:2 - Data_2
	{   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0 },	// Idx:3 - Data_3
	{   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0 },	// Idx:4 - Data_4
	{   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0 } 	// Idx:5 - Data_5
};

//----------------------------------------------------------
// Motion Name : HUNOBASIC_TURNRIGHT
//----------------------------------------------------------
#define HUNOBASIC_TURNRIGHT_NUM_OF_SCENES 6
#define HUNOBASIC_TURNRIGHT_NUM_OF_WCKS 16
unsigned char flash HUNOBASIC_TURNRIGHT_RuntimePGain[16]={
	/* ID
	  0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15 */
	 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 15, 15, 20, 15, 15, 15
};
unsigned char flash HUNOBASIC_TURNRIGHT_RuntimeDGain[16]={
	/* ID
	  0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15 */
	 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 20, 20, 30, 20, 20, 20
};
unsigned char flash HUNOBASIC_TURNRIGHT_RuntimeIGain[16]={
	/* ID
	  0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15 */
	  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
};
unsigned int flash HUNOBASIC_TURNRIGHT_Frames[6]={
	   10,    5,   10,    1,    5,   10
};
unsigned int flash HUNOBASIC_TURNRIGHT_TrTime[6]={
	  200,  200,  400,  120,  200,  400
};
unsigned char flash HUNOBASIC_TURNRIGHT_Position[7][16]={
	/* ID
	    0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15 */
	{ 125,179,199, 88,108,126, 72, 49,163,141, 51, 47, 49,199,205,205 },
	{ 125,179,199, 88,108,126, 72, 49,163,141, 51, 47, 49,199,205,205 },	// Idx:0 - Data_0
	{ 125,193,205,107,108,126, 89, 49,180,141, 51, 47, 49,199,205,205 },	// Idx:1 - Data
	{ 119,209,195,106, 96,119, 81, 31,157,132, 51, 47, 49,199,205,205 },	// Idx:2 - Data_2
	{ 117,162,227, 98,103,125, 78, 49,163,127, 51, 47, 49,199,205,205 },	// Idx:3 - Data_3
	{ 110,168,204, 85, 92,117, 81, 49,163,128, 51, 47, 49,199,205,205 },	// Idx:4 - Data_4
	{ 125,179,199, 88,108,126, 72, 49,163,141, 51, 47, 49,199,205,205 } 	// Idx:5 - Data_5
};
unsigned char flash HUNOBASIC_TURNRIGHT_Torque[6][16]={
	/* ID
	    0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15 */
	{   4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4 },	// Idx:0 - Data_0
	{   1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  4,  4,  4,  4,  4,  4 },	// Idx:1 - Data
	{   1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  4,  4,  4,  4,  4,  4 },	// Idx:2 - Data_2
	{   2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  4,  4,  4,  4,  4 },	// Idx:3 - Data_3
	{   2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  4,  4,  4,  4,  4 },	// Idx:4 - Data_4
	{   3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3 } 	// Idx:5 - Data_5
};
unsigned char flash HUNOBASIC_TURNRIGHT_Port[6][16]={
	/* ID
	    0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15 */
	{   0,  0,  0,  0,  0,  1,  1,  1,  1,  1,  0,  0,  0,  1,  1,  1 },	// Idx:0 - Data_0
	{   0,  0,  0,  0,  0,  1,  1,  1,  1,  1,  0,  0,  0,  1,  1,  0 },	// Idx:1 - Data
	{   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0 },	// Idx:2 - Data_2
	{   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0 },	// Idx:3 - Data_3
	{   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0 },	// Idx:4 - Data_4
	{   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0 } 	// Idx:5 - Data_5
};

//----------------------------------------------------------
// Motion Name : HUNOBASIC_GETUPBACK
//----------------------------------------------------------
#define HUNOBASIC_GETUPBACK_NUM_OF_SCENES 10
#define HUNOBASIC_GETUPBACK_NUM_OF_WCKS 16
unsigned char flash HUNOBASIC_GETUPBACK_RuntimePGain[16]={
	/* ID
	  0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15 */
	 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 15, 15, 15, 15, 15, 15
};
unsigned char flash HUNOBASIC_GETUPBACK_RuntimeDGain[16]={
	/* ID
	  0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15 */
	 60, 60, 60, 60, 60, 60, 60, 60, 60, 60, 20, 20, 20, 20, 20, 20
};
unsigned char flash HUNOBASIC_GETUPBACK_RuntimeIGain[16]={
	/* ID
	  0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15 */
	  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
};
unsigned int flash HUNOBASIC_GETUPBACK_Frames[10]={
	   15,   30,   45,   45,   45,   30,   30,   30,   30,   30
};
unsigned int flash HUNOBASIC_GETUPBACK_TrTime[10]={
	  300,  600,  900,  900,  900,  600,  600,  600,  600,  600
};
unsigned char flash HUNOBASIC_GETUPBACK_Position[11][16]={
	/* ID
	    0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15 */
	{ 125,179,199, 88,108,126, 72, 49,163,141, 51, 47, 49,199,205,205 },
	{ 125,179,199, 88,108,126, 72, 49,163,141, 51, 47, 49,199,205,205 },	// Idx:0 - Data_0
	{ 124,220,247,125,108,126, 29,  4,127,140, 51, 47, 49,199,205,205 },	// Idx:1 - Data
	{ 123,220,246, 86,112,126, 29,  7,169,139,  1, 59, 74,253,191,181 },	// Idx:2 - Data
	{ 130, 83,144, 63,108,125,170,103,191,139,  1, 59,163,253,191, 88 },	// Idx:3 - Data
	{ 130, 83,144, 63,108,125,170,103,191,139,234,125, 90,  5,129,166 },	// Idx:4 - Data
	{ 129, 94,183,100,110,128,162,110,186,136,160, 45, 81, 90,205,167 },	// Idx:5 - Data_21
	{ 129, 87,191, 60,110,128,162, 59,193,136,138, 46, 89,116,203,167 },	// Idx:6 - Data_22
	{ 129,129,190, 65,110,128,120, 59,187,140,133, 45, 81,116,203,167 },	// Idx:7 - Data_23
	{ 129,161,197, 71,110,128, 89, 53,181,143,143, 36, 89,116,203,167 },	// Idx:8 - Data_24
	{ 125,179,199, 88,108,126, 72, 49,163,141, 51, 47, 49,199,205,205 } 	// Idx:9 - Data_25
};
unsigned char flash HUNOBASIC_GETUPBACK_Torque[10][16]={
	/* ID
	    0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15 */
	{   4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4 },	// Idx:0 - Data_0
	{   4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4 },	// Idx:1 - Data
	{   3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3 },	// Idx:2 - Data
	{   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  4,  4,  4,  4,  4,  4 },	// Idx:3 - Data
	{   3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3 },	// Idx:4 - Data
	{   2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  4,  4,  4,  4,  4 },	// Idx:5 - Data_21
	{   2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  4,  4,  4,  4,  4 },	// Idx:6 - Data_22
	{   2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  4,  4,  4,  4,  4 },	// Idx:7 - Data_23
	{   2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  4,  4,  4,  4,  4,  4 },	// Idx:8 - Data_24
	{   3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  4,  4,  4,  4,  4,  4 } 	// Idx:9 - Data_25
};
unsigned char flash HUNOBASIC_GETUPBACK_Port[10][16]={
	/* ID
	    0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15 */
	{   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0 },	// Idx:0 - Data_0
	{   3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3 },	// Idx:1 - Data
	{   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0 },	// Idx:2 - Data
	{   2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2 },	// Idx:3 - Data
	{   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0 },	// Idx:4 - Data
	{   1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1 },	// Idx:5 - Data_21
	{   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0 },	// Idx:6 - Data_22
	{   3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3 },	// Idx:7 - Data_23
	{   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0 },	// Idx:8 - Data_24
	{   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0 } 	// Idx:9 - Data_25
};

//----------------------------------------------------------
// Motion Name : HUNOBASIC_GETUPFRONT
//----------------------------------------------------------
#define HUNOBASIC_GETUPFRONT_NUM_OF_SCENES 9
#define HUNOBASIC_GETUPFRONT_NUM_OF_WCKS 16
unsigned char flash HUNOBASIC_GETUPFRONT_RuntimePGain[16]={
	/* ID
	  0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15 */
	 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 15, 15, 15, 15, 15, 15
};
unsigned char flash HUNOBASIC_GETUPFRONT_RuntimeDGain[16]={
	/* ID
	  0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15 */
	 60, 60, 60, 60, 60, 60, 60, 60, 60, 60, 20, 20, 20, 20, 20, 20
};
unsigned char flash HUNOBASIC_GETUPFRONT_RuntimeIGain[16]={
	/* ID
	  0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15 */
	  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
};
unsigned int flash HUNOBASIC_GETUPFRONT_Frames[9]={
	   10,   10,   10,   10,    1,   35,   30,   40,   30
};
unsigned int flash HUNOBASIC_GETUPFRONT_TrTime[9]={
	  300,  500,  500,  700,  820,  700,  600,  800,  600
};
unsigned char flash HUNOBASIC_GETUPFRONT_Position[10][16]={
	/* ID
	    0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15 */
	{ 125,179,199, 88,108,126, 72, 49,163,141, 51, 47, 49,199,205,205 },
	{ 125,179,199, 88,108,126, 72, 49,163,141, 51, 47, 49,199,205,205 },	// Idx:0 - Data_0
	{ 125, 82,214, 89,108,126, 72, 49,163,141,143, 47, 49,114,205,205 },	// Idx:1 - Data_1
	{ 125, 82,218,101,114,125,166, 34,151,143,141, 47, 49,114,205,205 },	// Idx:2 - Data_2
	{ 125,210,228, 80,113,124, 35, 25,172,142,167, 47, 47, 82,205,204 },	// Idx:3 - Data_3
	{ 125,218,247, 86,113,123, 31,  5,168,141,  9, 87,146,254,162,108 },	// Idx:4 - Data_4
	{ 125,220,244,122,109,123, 29,  5,128,141, 33, 42,146,222,210,108 },	// Idx:5 - Data_5
	{ 125,220,222,122,113,123, 29, 28,135,141, 98, 50, 78,146,197,169 },	// Idx:6 - Data
	{ 125,160,242,114,113,123, 87,  8,135,141, 82, 47, 69,173,205,191 },	// Idx:7 - Data_6
	{ 125,179,199, 88,108,126, 72, 49,163,141, 51, 47, 49,199,205,205 } 	// Idx:8 - Data_7
};
unsigned char flash HUNOBASIC_GETUPFRONT_Torque[9][16]={
	/* ID
	    0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15 */
	{   4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4 },	// Idx:0 - Data_0
	{   1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  4,  4,  4,  4,  4,  4 },	// Idx:1 - Data_1
	{   4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4 },	// Idx:2 - Data_2
	{   1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1 },	// Idx:3 - Data_3
	{   1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1 },	// Idx:4 - Data_4
	{   2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2 },	// Idx:5 - Data_5
	{   2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2 },	// Idx:6 - Data
	{   2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2 },	// Idx:7 - Data_6
	{   4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4 } 	// Idx:8 - Data_7
};
unsigned char flash HUNOBASIC_GETUPFRONT_Port[9][16]={
	/* ID
	    0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15 */
	{   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0 },	// Idx:0 - Data_0
	{   3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3 },	// Idx:1 - Data_1
	{   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0 },	// Idx:2 - Data_2
	{   2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2 },	// Idx:3 - Data_3
	{   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0 },	// Idx:4 - Data_4
	{   1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1 },	// Idx:5 - Data_5
	{   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0 },	// Idx:6 - Data
	{   3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3 },	// Idx:7 - Data_6
	{   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0 } 	// Idx:8 - Data_7
};

//----------------------------------------------------------
// Motion Name : HUNOBASIC_WALKFORWARD
//----------------------------------------------------------
#define HUNOBASIC_WALKFORWARD_NUM_OF_SCENES 40
#define HUNOBASIC_WALKFORWARD_NUM_OF_WCKS 16
unsigned char flash HUNOBASIC_WALKFORWARD_RuntimePGain[16]={
	/* ID
	  0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15 */
	 41, 41, 41, 41, 41, 41, 41, 41, 41, 41, 15, 15, 15, 15, 15, 15
};
unsigned char flash HUNOBASIC_WALKFORWARD_RuntimeDGain[16]={
	/* ID
	  0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15 */
	 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 20, 20, 20, 20, 20, 20
};
unsigned char flash HUNOBASIC_WALKFORWARD_RuntimeIGain[16]={
	/* ID
	  0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15 */
	  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
};
unsigned int flash HUNOBASIC_WALKFORWARD_Frames[40]={
	    5,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
	    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
	    1,    1,    1,    1,    1,    1,    1,   10,   15
};
unsigned int flash HUNOBASIC_WALKFORWARD_TrTime[40]={
	  200,   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,
	   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,
	   25,   25,   25,   25,   25,   25,   25,  200,  300
};
unsigned char flash HUNOBASIC_WALKFORWARD_Position[41][16]={
	/* ID
	    0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15 */
	{ 125,179,199, 88,108,126, 72, 49,163,141, 51, 47, 49,199,205,205 },
	{ 125,179,199, 88,108,126, 72, 49,163,141, 51, 47, 49,199,205,205 },	// Idx:0 - 0
	{ 125,179,199, 88,108,126, 72, 49,163,141, 51, 47, 49,199,205,205 },	// Idx:1 - 0
	{ 130,165,201, 81,115,134, 81, 31,147,149, 72, 44, 40,145,209,201 },	// Idx:2 - 1
	{ 132,171,197, 83,117,137, 86, 28,148,152, 78, 43, 41,154,209,206 },	// Idx:3 - 2
	{ 132,175,195, 87,117,139, 91, 27,152,154, 87, 43, 43,164,209,211 },	// Idx:4 - 3
	{ 132,178,197, 91,117,137, 95, 28,157,152, 97, 43, 48,172,209,213 },	// Idx:5 - 4
	{ 130,179,201, 95,115,134, 96, 31,161,149,105, 43, 53,179,210,214 },	// Idx:6 - 5
	{ 127,178,206, 98,112,130, 95, 35,166,145,111, 42, 57,182,210,214 },	// Idx:7 - 6
	{ 124,175,212,100,109,127, 92, 40,170,142,113, 42, 59,183,210,214 },	// Idx:8 - 7
	{ 124,175,212,100,109,127, 92, 40,170,142,113, 42, 59,183,210,214 },	// Idx:9 - 8
	{ 120,172,217,102,105,123, 88, 46,170,138,111, 42, 57,182,210,214 },	// Idx:10 - 9
	{ 116,167,221,103,101,120, 83, 51,169,135,106, 43, 53,179,210,214 },	// Idx:11 - 10
	{ 113,162,224,102, 98,118, 77, 55,167,133, 97, 43, 48,173,209,213 },	// Idx:12 - 11
	{ 111,157,225, 98, 96,118, 73, 57,163,133, 87, 43, 43,164,209,211 },	// Idx:13 - 12
	{ 113,153,224, 93, 98,118, 70, 55,159,133, 79, 43, 41,154,209,206 },	// Idx:14 - 13
	{ 116,152,221, 89,101,120, 69, 51,155,135, 72, 44, 40,146,209,201 },	// Idx:15 - 14
	{ 120,153,217, 84,105,123, 70, 46,152,138, 69, 44, 40,140,208,197 },	// Idx:16 - 15
	{ 123,156,212, 80,108,126, 73, 40,150,141, 68, 44, 40,138,208,195 },	// Idx:17 - 16
	{ 123,156,212, 80,108,126, 73, 40,150,141, 68, 44, 40,138,208,195 },	// Idx:18 - 17
	{ 130,165,201, 81,115,134, 81, 31,147,149, 72, 44, 40,145,209,201 },	// Idx:19 - 1
	{ 132,171,197, 83,117,137, 86, 28,148,152, 78, 43, 41,154,209,206 },	// Idx:20 - 2
	{ 132,175,195, 87,117,139, 91, 27,152,154, 87, 43, 43,164,209,211 },	// Idx:21 - 3
	{ 132,178,197, 91,117,137, 95, 28,157,152, 97, 43, 48,172,209,213 },	// Idx:22 - 4
	{ 130,179,201, 95,115,134, 96, 31,161,149,105, 43, 53,179,210,214 },	// Idx:23 - 5
	{ 127,178,206, 98,112,130, 95, 35,166,145,111, 42, 57,182,210,214 },	// Idx:24 - 6
	{ 124,175,212,100,109,127, 92, 40,170,142,113, 42, 59,183,210,214 },	// Idx:25 - 7
	{ 124,175,212,100,109,127, 92, 40,170,142,113, 42, 59,183,210,214 },	// Idx:26 - 8
	{ 120,172,217,102,105,123, 88, 46,170,138,111, 42, 57,182,210,214 },	// Idx:27 - 9
	{ 116,167,221,103,101,120, 83, 51,169,135,106, 43, 53,179,210,214 },	// Idx:28 - 10
	{ 113,162,224,102, 98,118, 77, 55,167,133, 97, 43, 48,173,209,213 },	// Idx:29 - 11
	{ 111,157,225, 98, 96,118, 73, 57,163,133, 87, 43, 43,164,209,211 },	// Idx:30 - 12
	{ 113,153,224, 93, 98,118, 70, 55,159,133, 79, 43, 41,154,209,206 },	// Idx:31 - 13
	{ 116,152,221, 89,101,120, 69, 51,155,135, 72, 44, 40,146,209,201 },	// Idx:32 - 14
	{ 120,153,217, 84,105,123, 70, 46,152,138, 69, 44, 40,140,208,197 },	// Idx:33 - 15
	{ 123,156,212, 80,108,126, 73, 40,150,141, 68, 44, 40,138,208,195 },	// Idx:34 - 16
	{ 123,156,212, 80,108,126, 73, 40,150,141, 68, 44, 40,138,208,195 },	// Idx:35 - 17
	{ 130,165,201, 81,115,134, 81, 31,147,149, 72, 44, 40,145,209,201 },	// Idx:36 - 1
	{ 132,171,197, 83,117,137, 86, 28,148,152, 78, 43, 41,154,209,206 },	// Idx:37 - 2
	{ 125,166,229,106,108,126, 86, 23,150,141, 51, 47, 49,199,205,205 },	// Idx:38 - 3
	{ 125,179,199, 88,108,126, 72, 49,163,141, 51, 47, 49,199,205,205 } 	// Idx:39 - Data
};
unsigned char flash HUNOBASIC_WALKFORWARD_Torque[40][16]={
	/* ID
	    0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15 */
	{   3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3 },	// Idx:0 - 0
	{   3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3 },	// Idx:1 - 0
	{   3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3 },	// Idx:2 - 1
	{   2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2 },	// Idx:3 - 2
	{   1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1 },	// Idx:4 - 3
	{   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0 },	// Idx:5 - 4
	{   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0 },	// Idx:6 - 5
	{   1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1 },	// Idx:7 - 6
	{   2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2 },	// Idx:8 - 7
	{   3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3 },	// Idx:9 - 8
	{   3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3 },	// Idx:10 - 9
	{   3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3 },	// Idx:11 - 10
	{   2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2 },	// Idx:12 - 11
	{   1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1 },	// Idx:13 - 12
	{   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0 },	// Idx:14 - 13
	{   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0 },	// Idx:15 - 14
	{   1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1 },	// Idx:16 - 15
	{   2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2 },	// Idx:17 - 16
	{   3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3 },	// Idx:18 - 17
	{   3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3 },	// Idx:19 - 1
	{   2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2 },	// Idx:20 - 2
	{   1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1 },	// Idx:21 - 3
	{   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0 },	// Idx:22 - 4
	{   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0 },	// Idx:23 - 5
	{   1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1 },	// Idx:24 - 6
	{   2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2 },	// Idx:25 - 7
	{   3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3 },	// Idx:26 - 8
	{   3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3 },	// Idx:27 - 9
	{   3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3 },	// Idx:28 - 10
	{   2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2 },	// Idx:29 - 11
	{   1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1 },	// Idx:30 - 12
	{   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0 },	// Idx:31 - 13
	{   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0 },	// Idx:32 - 14
	{   1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1 },	// Idx:33 - 15
	{   2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2 },	// Idx:34 - 16
	{   3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3 },	// Idx:35 - 17
	{   3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3 },	// Idx:36 - 1
	{   2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2 },	// Idx:37 - 2
	{   1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1 },	// Idx:38 - 3
	{   4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4 } 	// Idx:39 - Data
};
unsigned char flash HUNOBASIC_WALKFORWARD_Port[40][16]={
	/* ID
	    0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15 */
	{   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0 },	// Idx:0 - 0
	{   3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3 },	// Idx:1 - 0
	{   3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3 },	// Idx:2 - 1
	{   2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2 },	// Idx:3 - 2
	{   1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1 },	// Idx:4 - 3
	{   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0 },	// Idx:5 - 4
	{   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0 },	// Idx:6 - 5
	{   1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1 },	// Idx:7 - 6
	{   2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2 },	// Idx:8 - 7
	{   3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3 },	// Idx:9 - 8
	{   3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3 },	// Idx:10 - 9
	{   3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3 },	// Idx:11 - 10
	{   2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2 },	// Idx:12 - 11
	{   1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1 },	// Idx:13 - 12
	{   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0 },	// Idx:14 - 13
	{   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0 },	// Idx:15 - 14
	{   1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1 },	// Idx:16 - 15
	{   2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2 },	// Idx:17 - 16
	{   3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3 },	// Idx:18 - 17
	{   3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3 },	// Idx:19 - 1
	{   2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2 },	// Idx:20 - 2
	{   1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1 },	// Idx:21 - 3
	{   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0 },	// Idx:22 - 4
	{   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0 },	// Idx:23 - 5
	{   1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1 },	// Idx:24 - 6
	{   2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2 },	// Idx:25 - 7
	{   3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3 },	// Idx:26 - 8
	{   3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3 },	// Idx:27 - 9
	{   3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3 },	// Idx:28 - 10
	{   2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2 },	// Idx:29 - 11
	{   1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1 },	// Idx:30 - 12
	{   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0 },	// Idx:31 - 13
	{   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0 },	// Idx:32 - 14
	{   1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1 },	// Idx:33 - 15
	{   2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2 },	// Idx:34 - 16
	{   3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3 },	// Idx:35 - 17
	{   3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3 },	// Idx:36 - 1
	{   2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2 },	// Idx:37 - 2
	{   1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1 },	// Idx:38 - 3
	{   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0 } 	// Idx:39 - Data
};

//----------------------------------------------------------
// Motion Name : HUNOBASIC_WALKBACKWARD
//----------------------------------------------------------
#define HUNOBASIC_WALKBACKWARD_NUM_OF_SCENES 42
#define HUNOBASIC_WALKBACKWARD_NUM_OF_WCKS 16
unsigned char flash HUNOBASIC_WALKBACKWARD_RuntimePGain[16]={
	/* ID
	  0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15 */
	 41, 41, 41, 41, 41, 41, 41, 41, 41, 41, 15, 15, 15, 15, 15, 15
};
unsigned char flash HUNOBASIC_WALKBACKWARD_RuntimeDGain[16]={
	/* ID
	  0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15 */
	 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 20, 20, 20, 20, 20, 20
};
unsigned char flash HUNOBASIC_WALKBACKWARD_RuntimeIGain[16]={
	/* ID
	  0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15 */
	  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
};
unsigned int flash HUNOBASIC_WALKBACKWARD_Frames[42]={
	    5,   20,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
	    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
	    1,    1,    1,    1,    1,    1,    1,    1,    1,   10,   20
};
unsigned int flash HUNOBASIC_WALKBACKWARD_TrTime[42]={
	  300,  400,   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,
	   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,
	   25,   25,   25,   25,   25,   25,   25,   25,   25,  400,  400
};
unsigned char flash HUNOBASIC_WALKBACKWARD_Position[43][16]={
	/* ID
	    0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15 */
	{ 125,179,199, 88,108,126, 72, 49,163,141, 51, 47, 49,199,205,205 },
	{ 125,179,199, 88,108,126, 72, 49,163,141, 51, 47, 49,199,205,205 },	// Idx:0 - Data
	{ 125,160,220,107,108,126, 88, 31,146,141, 51, 47, 49,199,205,205 },	// Idx:1 - Data
	{ 120,153,218, 88,105,123, 72, 46,151,138, 57, 43, 51,174,210,214 },	// Idx:2 - Data
	{ 116,151,223, 91,101,120, 70, 52,155,135, 58, 43, 48,177,210,214 },	// Idx:3 - 1
	{ 112,152,226, 94, 97,119, 70, 57,160,134, 59, 43, 45,182,210,214 },	// Idx:4 - 2
	{ 111,155,227, 99, 96,118, 72, 60,165,133, 63, 43, 41,188,209,213 },	// Idx:5 - 3
	{ 112,160,226,102, 97,118, 76, 58,167,133, 68, 44, 40,191,209,209 },	// Idx:6 - 4
	{ 115,165,223,104,100,120, 82, 52,168,135, 73, 44, 40,193,209,206 },	// Idx:7 - 5
	{ 120,169,218,104,105,123, 88, 46,167,138, 77, 44, 40,194,209,203 },	// Idx:8 - 6
	{ 123,173,212,103,108,126, 92, 40,165,141, 78, 43, 40,194,209,202 },	// Idx:9 - 7
	{ 123,173,212,103,108,126, 92, 40,165,141, 78, 43, 40,194,209,202 },	// Idx:10 - 8
	{ 127,176,206, 99,112,130, 95, 34,162,145, 77, 44, 40,194,209,203 },	// Idx:11 - 9
	{ 130,178,200, 95,115,134, 97, 29,159,149, 74, 44, 40,193,209,206 },	// Idx:12 - 10
	{ 131,178,195, 90,116,138, 96, 26,156,153, 69, 44, 40,192,209,209 },	// Idx:13 - 11
	{ 132,176,192, 85,117,139, 93, 25,151,154, 63, 43, 41,188,209,213 },	// Idx:14 - 12
	{ 132,172,194, 83,117,138, 88, 26,148,153, 60, 43, 45,183,210,214 },	// Idx:15 - 13
	{ 130,166,200, 82,115,135, 83, 29,146,150, 58, 43, 48,178,210,214 },	// Idx:16 - 14
	{ 127,160,206, 83,112,130, 79, 34,146,145, 57, 43, 51,174,210,214 },	// Idx:17 - 15
	{ 124,156,212, 85,109,127, 75, 40,147,142, 57, 43, 52,173,209,214 },	// Idx:18 - 16
	{ 124,156,212, 85,109,127, 75, 40,147,142, 57, 43, 52,173,209,214 },	// Idx:19 - 17
	{ 116,151,223, 91,101,120, 70, 52,155,135, 58, 43, 48,177,210,214 },	// Idx:20 - 1
	{ 112,152,226, 94, 97,119, 70, 57,160,134, 59, 43, 45,182,210,214 },	// Idx:21 - 2
	{ 111,155,227, 99, 96,118, 72, 60,165,133, 63, 43, 41,188,209,213 },	// Idx:22 - 3
	{ 112,160,226,102, 97,118, 76, 58,167,133, 68, 44, 40,191,209,209 },	// Idx:23 - 4
	{ 115,165,223,104,100,120, 82, 52,168,135, 73, 44, 40,193,209,206 },	// Idx:24 - 5
	{ 120,169,218,104,105,123, 88, 46,167,138, 77, 44, 40,194,209,203 },	// Idx:25 - 6
	{ 123,173,212,103,108,126, 92, 40,165,141, 78, 43, 40,194,209,202 },	// Idx:26 - 7
	{ 123,173,212,103,108,126, 92, 40,165,141, 78, 43, 40,194,209,202 },	// Idx:27 - 8
	{ 127,176,206, 99,112,130, 95, 34,162,145, 77, 44, 40,194,209,203 },	// Idx:28 - 9
	{ 130,178,200, 95,115,134, 97, 29,159,149, 74, 44, 40,193,209,206 },	// Idx:29 - 10
	{ 131,178,195, 90,116,138, 96, 26,156,153, 69, 44, 40,192,209,209 },	// Idx:30 - 11
	{ 132,176,192, 85,117,139, 93, 25,151,154, 63, 43, 41,188,209,213 },	// Idx:31 - 12
	{ 132,172,194, 83,117,138, 88, 26,148,153, 60, 43, 45,183,210,214 },	// Idx:32 - 13
	{ 130,166,200, 82,115,135, 83, 29,146,150, 58, 43, 48,178,210,214 },	// Idx:33 - 14
	{ 127,160,206, 83,112,130, 79, 34,146,145, 57, 43, 51,174,210,214 },	// Idx:34 - 15
	{ 124,156,212, 85,109,127, 75, 40,147,142, 57, 43, 52,173,209,214 },	// Idx:35 - 16
	{ 124,156,212, 85,109,127, 75, 40,147,142, 57, 43, 52,173,209,214 },	// Idx:36 - 17
	{ 116,151,223, 91,101,120, 70, 52,155,135, 58, 43, 48,177,210,214 },	// Idx:37 - 1
	{ 112,152,226, 94, 97,119, 70, 57,160,134, 59, 43, 45,182,210,214 },	// Idx:38 - 2
	{ 111,155,227, 99, 96,118, 72, 60,165,133, 63, 43, 41,188,209,213 },	// Idx:39 - 3
	{ 111,155,227, 98, 96,118, 89, 25,155,133, 63, 43, 41,188,209,213 },	// Idx:40 - Scene_40
	{ 125,179,199, 88,108,126, 72, 49,163,141, 51, 47, 49,199,205,205 } 	// Idx:41 - Scene_41
};
unsigned char flash HUNOBASIC_WALKBACKWARD_Torque[42][16]={
	/* ID
	    0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15 */
	{   4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4 },	// Idx:0 - Data
	{   3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3 },	// Idx:1 - Data
	{   2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2 },	// Idx:2 - Data
	{   3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3 },	// Idx:3 - 1
	{   2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2 },	// Idx:4 - 2
	{   1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1 },	// Idx:5 - 3
	{   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0 },	// Idx:6 - 4
	{   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0 },	// Idx:7 - 5
	{   1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1 },	// Idx:8 - 6
	{   2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2 },	// Idx:9 - 7
	{   3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3 },	// Idx:10 - 8
	{   3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3 },	// Idx:11 - 9
	{   3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3 },	// Idx:12 - 10
	{   2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2 },	// Idx:13 - 11
	{   1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1 },	// Idx:14 - 12
	{   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0 },	// Idx:15 - 13
	{   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0 },	// Idx:16 - 14
	{   1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1 },	// Idx:17 - 15
	{   2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2 },	// Idx:18 - 16
	{   3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3 },	// Idx:19 - 17
	{   3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3 },	// Idx:20 - 1
	{   2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2 },	// Idx:21 - 2
	{   1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1 },	// Idx:22 - 3
	{   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0 },	// Idx:23 - 4
	{   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0 },	// Idx:24 - 5
	{   1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1 },	// Idx:25 - 6
	{   2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2 },	// Idx:26 - 7
	{   3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3 },	// Idx:27 - 8
	{   3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3 },	// Idx:28 - 9
	{   3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3 },	// Idx:29 - 10
	{   2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2 },	// Idx:30 - 11
	{   1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1 },	// Idx:31 - 12
	{   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0 },	// Idx:32 - 13
	{   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0 },	// Idx:33 - 14
	{   1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1 },	// Idx:34 - 15
	{   2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2 },	// Idx:35 - 16
	{   3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3 },	// Idx:36 - 17
	{   3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3 },	// Idx:37 - 1
	{   2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2 },	// Idx:38 - 2
	{   1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1 },	// Idx:39 - 3
	{   2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2 },	// Idx:40 - Scene_40
	{   4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4 } 	// Idx:41 - Scene_41
};
unsigned char flash HUNOBASIC_WALKBACKWARD_Port[42][16]={
	/* ID
	    0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15 */
	{   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0 },	// Idx:0 - Data
	{   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0 },	// Idx:1 - Data
	{   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0 },	// Idx:2 - Data
	{   3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3 },	// Idx:3 - 1
	{   2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2 },	// Idx:4 - 2
	{   1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1 },	// Idx:5 - 3
	{   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0 },	// Idx:6 - 4
	{   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0 },	// Idx:7 - 5
	{   1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1 },	// Idx:8 - 6
	{   2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2 },	// Idx:9 - 7
	{   3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3 },	// Idx:10 - 8
	{   3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3 },	// Idx:11 - 9
	{   3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3 },	// Idx:12 - 10
	{   2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2 },	// Idx:13 - 11
	{   1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1 },	// Idx:14 - 12
	{   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0 },	// Idx:15 - 13
	{   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0 },	// Idx:16 - 14
	{   1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1 },	// Idx:17 - 15
	{   2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2 },	// Idx:18 - 16
	{   3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3 },	// Idx:19 - 17
	{   3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3 },	// Idx:20 - 1
	{   2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2 },	// Idx:21 - 2
	{   1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1 },	// Idx:22 - 3
	{   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0 },	// Idx:23 - 4
	{   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0 },	// Idx:24 - 5
	{   1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1 },	// Idx:25 - 6
	{   2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2 },	// Idx:26 - 7
	{   3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3 },	// Idx:27 - 8
	{   3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3 },	// Idx:28 - 9
	{   3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3 },	// Idx:29 - 10
	{   2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2 },	// Idx:30 - 11
	{   1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1 },	// Idx:31 - 12
	{   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0 },	// Idx:32 - 13
	{   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0 },	// Idx:33 - 14
	{   1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1 },	// Idx:34 - 15
	{   2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2 },	// Idx:35 - 16
	{   3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3 },	// Idx:36 - 17
	{   3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3 },	// Idx:37 - 1
	{   2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2 },	// Idx:38 - 2
	{   1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1 },	// Idx:39 - 3
	{   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0 },	// Idx:40 - Scene_40
	{   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0 } 	// Idx:41 - Scene_41
};

